module.exports = function() {
  return {
    flattenComponents: function flatten(components, flattened) {
      flattened = flattened || {};
      angular.forEach(components, function(component) {
        if (component.tree) {
          flattened[component.key] = component;
        }
        else if (component.columns && (component.columns.length > 0)) {
          angular.forEach(component.columns, function(column) {
            flatten(column.components, flattened);
          });
        }
        else if (component.components && (component.components.length > 0)) {
          flatten(component.components, flattened);
        }
        else if (component.input) {
          flattened[component.key] = component;
        }
      });
      return flattened;
    },
    eachComponent: function eachComponent(components, fn) {
      if (!components) {
        return;
      }
      angular.forEach(components, function(component) {
        if (component.columns) {
          angular.forEach(component.columns, function(column) {
            eachComponent(column.components, fn);
          });
        }
        else if (component.components) {
          eachComponent(component.components, fn);
        }
        else {
          fn(component);
        }
      });
    },
    getComponent: function getComponent(components, key) {
      var result;
      this.eachComponent(components, function(component) {
        if (component.key === key) {
          result = component;
        }
      });
      return result;
    },
    fieldWrap: function(input) {
      input = input + '<formio-errors></formio-errors>';
      var multiInput = input.replace('data[component.key]', 'data[component.key][$index]');
      var inputLabel = '<label ng-if="component.label && !component.hideLabel" for="{{ component.key }}" class="control-label" ng-class="{\'field-required\': component.validate.required}">{{ component.label }}</label>';
      var requiredInline = '<span ng-if="!component.label && component.validate.required" class="glyphicon glyphicon-asterisk form-control-feedback field-required-inline" aria-hidden="true"></span>';
      var template =
        '<div ng-if="!component.multiple">' +
        inputLabel + requiredInline +
        '<div class="input-group" ng-if="component.prefix || component.suffix">' +
        '<div class="input-group-addon" ng-if="!!component.prefix">{{ component.prefix }}</div>' +
        input +
        '<div class="input-group-addon" ng-if="!!component.suffix">{{ component.suffix }}</div>' +
        '</div>' +
        '<div ng-if="!component.prefix && !component.suffix">' + input + '</div>' +
        '</div>' +
        '<div ng-if="component.multiple"><table class="table table-bordered">' +
        inputLabel +
        '<tr ng-repeat="value in data[component.key] track by $index">' +
        '<td>' + requiredInline +
        '<div class="input-group" ng-if="component.prefix || component.suffix">' +
        '<div class="input-group-addon" ng-if="!!component.prefix">{{ component.prefix }}</div>' +
        multiInput +
        '<div class="input-group-addon" ng-if="!!component.suffix">{{ component.suffix }}</div>' +
        '</div>' +
        '<div ng-if="!component.prefix && !component.suffix">' + multiInput + '</div>' +
        '</td>' +
        '<td><a ng-click="removeFieldValue($index)" class="btn btn-danger"><span class="glyphicon glyphicon-remove-circle"></span></a></td>' +
        '</tr>' +
        '<tr>' +
        '<td colspan="2"><a ng-click="addFieldValue()" class="btn btn-primary"><span class="glyphicon glyphicon-plus" aria-hidden="true"></span> Add another</a></td>' +
        '</tr>' +
        '</table></div>';
      return template;
    }
  };
};
